package org.openmuc.jsml.structures;

public class SML_TimestampLocal extends Sequence {

  protected SML_Timestamp timestamp;
  protected Integer16 localOffset;
  protected Integer16 seasonTimeOffset;

  public SML_Timestamp getTimestamp() {
    return timestamp;
  }

  public Integer16 getLocalOffset() {
    return localOffset;
  }

  public Integer16 getSeasonTimeOffset() {
    return seasonTimeOffset;
  }

  public SML_TimestampLocal(SML_Timestamp timestamp, Integer16 localOffset, Integer16 seasonTimeOffset) {

    if (timestamp == null)
      throw new IllegalArgumentException("SML_TimestampLocal: timestamp is not optional and must not be null!");
    if (localOffset == null)
      throw new IllegalArgumentException("SML_TimestampLocal: localOffset is not optional and must not be null!");
    if (seasonTimeOffset == null)
      throw new IllegalArgumentException("SML_TimestampLocal: seasonTimeOffset is not optional and must not be null!");

    this.timestamp = timestamp;
    this.localOffset = localOffset;
    this.seasonTimeOffset = seasonTimeOffset;

    setOptionalAndSeq();
    isSelected = true;
  }

  public SML_TimestampLocal() {
  }

  public void setOptionalAndSeq() {
    seqArray = new ASNObject[] { timestamp, localOffset, seasonTimeOffset };
  }

  protected void createElements() {
    timestamp = new SML_Timestamp();
    localOffset = new Integer16();
    seasonTimeOffset = new Integer16();
    setOptionalAndSeq();
  }

  public void print() {
    if (!isOptional || isSelected) {
      System.out.println("SML_TimestampLocal: ");
      super.print();
    }
  }

}
